#ifndef MSP_AL_JUKEBOX_H_
#define MSP_AL_JUKEBOX_H_

#include <list>
#include <string>
#include <sigc++/signal.h>
#include <msp/io/seekable.h>
#include "source.h"
#include "streamer.h"

namespace Msp {
namespace AL {

class Playlist;
class SoundDecoder;

class Jukebox
{
public:
	sigc::signal<void, unsigned> signal_track_changed;

private:
	Source source;
	Streamer streamer;
	IO::Seekable *in;
	SoundDecoder *decoder;
	const Playlist *playlist;
	unsigned current;

public:
	Jukebox();
	~Jukebox();

	Source &get_source() { return source; }
	void set_playlist(const Playlist *);
	const Playlist *get_playlist() const { return playlist; }
	unsigned get_current_track() const { return current; }

	void play();
	void next();
	void previous();
	void stop();
	void tick();
};

} // namespace AL
} // namespace Msp

#endif
