#include "listener.h"

namespace Msp {
namespace AL {

Listener::Listener()
{
	orientation[0] = 0;
	orientation[1] = 0;
	orientation[2] = -1;
	orientation[3] = 0;
	orientation[4] = 1;
	orientation[5] = 0;
}

Listener &Listener::instance()
{
	static Listener listener;
	return listener;
}

void Listener::set_position(float x, float y, float z)
{
	alListener3f(AL_POSITION, x, y, z);
}

void Listener::set_forward_direction(float x, float y, float z)
{
	orientation[0] = x;
	orientation[1] = y;
	orientation[2] = z;
	alListenerfv(AL_ORIENTATION, orientation);
}

void Listener::set_up_direction(float x, float y, float z)
{
	orientation[3] = x;
	orientation[4] = y;
	orientation[5] = z;
	alListenerfv(AL_ORIENTATION, orientation);
}

void Listener::set_velocity(float x, float y, float z)
{
	alListener3f(AL_VELOCITY, x, y, z);
}

void Listener::set_gain(float g)
{
	alListenerf(AL_GAIN, g);
}

} // namespace AL
} // namespace Msp
