#ifndef MSP_AL_SOUNDSCAPE_H_
#define MSP_AL_SOUNDSCAPE_H_

#include <list>

namespace Msp {
namespace AL {

class Buffer;
class Source;

/**
A SoundScape offers an easy way to play positional sound effects.
*/
class SoundScape
{
private:
	float gain;
	std::list<Source *> sources;

public:
	SoundScape();
	~SoundScape();

	void set_gain(float);
	void add_source(Source &);
	Source &play(const Buffer &, float, float, float);
	void tick();
};

} // namespace AL
} // namespace Msp

#endif
